com.io7m.jstructural.annotated

## Class SAParagraph

- java.lang.Object
- - com.io7m.jstructural.annotated.SAParagraph

- All Implemented Interfaces:
    SAIDTargetContent, SASubsectionContent

      @Immutable
      public final class SAParagraph
      extends Object
      implements SASubsectionContent, SAIDTargetContent

  A paragraph element.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SAParagraph(SAParagraphNumber in_number, com.io7m.jaux.functional.Option<String> in_type, SNonEmptyList<SAParagraphContent> in_content, com.io7m.jaux.functional.Option<SAID> in_id)` Construct a new paragraph.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `SNonEmptyList<SAParagraphContent>` | `getContent()`
    `com.io7m.jaux.functional.Option<SAID>` | `getID()`
    `SAParagraphNumber` | `getNumber()`
    `com.io7m.jaux.functional.Option<String>` | `getType()`
    `int` | `hashCode()`
    `<A> A` | `subsectionContentAccept(SASubsectionContentVisitor<A> v)` Accept a section content visitor.
    `<T> T` | `targetContentAccept(SAIDTargetContentVisitor<T> v)` Accept an ID target content visitor.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SAParagraph

          public SAParagraph(@Nonnull
                     SAParagraphNumber in_number,
                     @Nonnull
                     com.io7m.jaux.functional.Option<String> in_type,
                     @Nonnull
                     SNonEmptyList<SAParagraphContent> in_content,
                     @Nonnull
                     com.io7m.jaux.functional.Option<SAID> in_id)
                      throws com.io7m.jaux.Constraints.ConstraintError

      Construct a new paragraph.
      Parameters:
        `in_number` - The paragraph number
        `in_type` - The type attribute
        `in_id` - The ID
        `in_content` - The paragraph content.
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If any parameter is `null`

  - ### Method Detail

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getContent

          @Nonnull
          public SNonEmptyList<SAParagraphContent> getContent()

      Returns:
        The element content

    - #### getID

          @Nonnull
          public com.io7m.jaux.functional.Option<SAID> getID()

      Returns:
        The paragraph's ID.

    - #### getNumber

          @Nonnull
          public SAParagraphNumber getNumber()

      Returns:
        The paragraph number

    - #### getType

          @Nonnull
          public com.io7m.jaux.functional.Option<String> getType()

      Returns:
        The type attribute

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### subsectionContentAccept

          public <A> A subsectionContentAccept(@Nonnull
                                      SASubsectionContentVisitor<A> v)
                                    throws com.io7m.jaux.Constraints.ConstraintError,
                                           Exception

      Description copied from interface: `SASubsectionContent`
      Accept a section content visitor.
      Specified by:
        `subsectionContentAccept` in interface `SASubsectionContent`
      Type Parameters:
        `A` - The type of values returned by the visitor
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor.
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises a `Constraints.ConstraintError`
        `Exception` - If the visitor raises and `Exception`

    - #### targetContentAccept

          public <T> T targetContentAccept(@Nonnull
                                  SAIDTargetContentVisitor<T> v)
                                throws com.io7m.jaux.Constraints.ConstraintError,
                                       Exception

      Description copied from interface: `SAIDTargetContent`
      Accept an ID target content visitor.
      Specified by:
        `targetContentAccept` in interface `SAIDTargetContent`
      Type Parameters:
        `T` - The type of values returned by the visitor
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor.
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises a `Constraints.ConstraintError`
        `Exception` - If the visitor raises and `Exception`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2014 <code@io7m.com> http://io7m.com